<template>
  <view>
    <cu-custom bgColor="bg-gradual-blueness" :isBack="!selectMeasuresShow">
      <block slot="backText">返回</block>
      <block slot="content">选择安全措施确认人</block>
    </cu-custom>
    <scroll-view scroll-y="false">
      <view class="form">
        <detail v-if="pd.HOISTING_ID" :hoistingId="pd.HOISTING_ID" :showMeasures="false"></detail>

        <view class="wui-form-list" style="padding-top: 20upx;">
          <view class="wui-title"
                style="margin-left: 20upx;display: flex;justify-content: space-between;align-items: center">
            <text class="text-semi">安全防护措施</text>
            <button class="cu-btn round bg-blue" @click="addMeasuresListCopy" style="margin-right: 20upx;">添加</button>
          </view>
          <view>
            <view class="add_pard_item" v-for="(item,index) in measuresListCopy" :key="item.id">
              <view class="add_pard_del" @click="removeMeasuresListCopy(index)" v-if="index !== 0">
                <text class="cuIcon-roundclosefill text-red f40"></text>
              </view>
              <view class="cu-form-group">
                <view class="title">确认单位：</view>
                <view class="picker-tree-box">
                  <view class="picker-tree" @tap="showDeptTree(index)">
                    {{ item.DEPARTMENT_NAME ? item.DEPARTMENT_NAME : '请选择' }}
                  </view>
                </view>
                <tki-tree
                    :ref="'tkiTree'+index"
                    :selectParent=true
                    :range="treeNode"
                    rangeKey="name"
                    @confirm="deptTreeConfirm($event,index)"
                    @cancel="deptTreeCancel($event,index)">
                </tki-tree>
              </view>
              <view class="cu-form-group">
                <view class="title">确认人</view>
                <picker
                    @change="pickerUser($event,index)"
                    :value="item.userIndex"
                    :range="item.userList"
                    range-key="NAME"
                    :disabled="item.userList.length === 0"
                    @click="isBlankList(index)"
                >
                  <view class="picker">
                    {{ item.USER_NAME ? item.USER_NAME : '请选择' }}
                  </view>
                </picker>
              </view>
              <view class="measures cu-form-group">
                <view style="flex: 1">
                  <view style="margin-top: 10upx;display: flex;justify-content: space-between;align-items: center">
                    <view class="title">安全措施：</view>
                    <view>
                      <button class="cu-btn round bg-blue" @click="fnSelectMeasures(index)">选择安全措施</button>
                    </view>
                  </view>
                  <view class="content" v-for="(item1,index1) in item.selectMeasures" :key="index1">
                    {{ index1 + 1 }} . {{ item1.PROTECTIVE_MEASURES }}
                  </view>
                </view>
              </view>
            </view>
          </view>
          <view class="wui-sign">
            <view class="title"></view>
            <button class="cu-btn bg-green shadow" @tap="showModal" data-target="Modal">新增手写签字</button>
          </view>
          <view class="wui-sign-box wui-sign-box1" v-show="imgList && imgList.length > 0">
            <view class="sign-title">
              签字照片：
            </view>
            <view class="wui-sign-cotent">
              <view class="sign-img" v-for="(item,index) in imgList" :key="index" @tap="ViewImage" data-type="0"
                    :data-url="imgList[index].filePath">
                <image :src="imgList[index].filePath" mode="aspectFit"></image>
                <view class="cu-tag bg-red" @tap.stop="DelImg(index)">
                  <text class='cuIcon-close'></text>
                </view>
              </view>
            </view>
          </view>
          <view class="cu-modal" :class="modalName=='Modal'?'show':''">
            <writing-board :signShow="modalName =='Modal'" @confirm="subCanvas" @cancel="hideModal"/>
          </view>
        </view>
      </view>
      <view class="cu-bar btn-group" style="margin-top: 30upx;">
        <button class="cu-btn bg-red margin-tb-sm lg" @click="$noMultipleClicks(goSubmit,'-1')">作废</button>
        <button class="cu-btn bg-green margin-tb-sm lg" @click="$noMultipleClicks(goSubmit,'1')">通过</button>
      </view>
      <view class="padding flex flex-direction">
      </view>
    </scroll-view>
    <select-measures :measures-list="measuresList" v-model="measuresListCopy" :visible.sync="selectMeasuresShow"
                     :index="selectMeasuresIndex" row-key="BUS_HOISTING_MEASURES_ID"/>
  </view>
</template>

<script>
import {
  basePath, corpinfoId, deptId, loginUser, formatDate, loginSession, baseImgPath
} from '@/common/tool.js';
import tkiTree from "@/components/select-tree/select-tree.vue"
import writingBoard from "@/components/horizontal-writing-board/writing-board.vue"
import gcoord from '@/common/gcoord.js'
import ruiDatePicker from '@/components/rattenking-dtpicker/rattenking-dtpicker.vue';
import detail from '@/pages/application/hoisting/hoisting-detail/index'
import selectMeasures from "@/components/select_measures/index.vue";

export default {
  components: {
    tkiTree, ruiDatePicker, writingBoard, detail, selectMeasures
  },
  data() {
    return {
      baseImgPath: baseImgPath,
      buttonloading: false,
      noClick: true,
      treeNode: [],//部门下拉数据
      pd: {},// 数据
      measuresList: [],
      measuresListCopy: [],
      selectMeasuresShow: false,
      selectMeasuresIndex: -1,
      modalName: null,
      imgList: [],
    }
  },
  onLoad(event) {
    this.pd.HOISTING_ID = event.HOISTING_ID;
    this.getData();
    // 初始化现场作业负责人
    this.getDept();
    this.getMeasures();
    this.addMeasuresListCopy();

    loginSession();
  },
  methods: {

    getData() {
      var _this = this;
      uni.showLoading({
        title: '请稍候'
      })
      uni.request({
        url: basePath + '/app/hoisting/findById',
        method: 'POST',
        header: {
          'Content-type': 'application/x-www-form-urlencoded'
        },
        data: {
          HOISTING_ID: _this.pd.HOISTING_ID,
          CORPINFO_ID: loginUser.CORPINFO_ID,
          USER_ID: loginUser.USER_ID,
        },
        success: (res) => {
          if ("success" == res.data.result) {
            uni.hideLoading();
            _this.pd = res.data.pd; //参数map
          } else if ("exception" == data.result) {
            uni.showToast({
              title: '错误',
              duration: 2000
            });
          }
        }
      });
    },

    goSubmit(APPLY_STATUS) {
      var _this = this;
      if (_this.imgList.length <= 0) {
        uni.showToast({
          icon: 'none',
          title: '请签字',
          duration: 1500
        });
        return;
      }
      if (APPLY_STATUS == 1) {
        for (let i = 0; i < this.measuresListCopy.length; i++) {
          const measures = this.measuresListCopy[i]
          if (!measures.USER_ID) {
            uni.showToast({
              icon: 'none',
              title: '第' + (i + 1) + '项未设置确认人',
              duration: 1500
            });
            return;
          }
          if (measures.selectMeasures.length === 0) {
            uni.showToast({
              icon: 'none',
              title: '第' + (i + 1) + '项未选择安全措施',
              duration: 1500
            });
            return;
          }
        }
      }
      var files = [];
      var signtime = [];
      var signers = [];
      if (APPLY_STATUS == 1) {
        for (let i = 0; i < this.measuresListCopy.length; i++) {
          const measures = this.measuresListCopy[i]
          for (let j = 0; j < measures.selectMeasures.length; j++) {
            signers.push({
              BUS_HOISTING_MEASURES_ID: measures.selectMeasures[j].BUS_HOISTING_MEASURES_ID,
              USER_ID: measures.USER_ID
            })
          }
        }
        if (signers.length !== this.measuresList.length) {
          uni.showToast({
            icon: 'none',
            title: '请为每个安全措施选择确认人',
            duration: 1500
          });
          return;
        }
      }
      this.uploadImgFaults(files, signtime)
      uni.showModal({
        title: '请确认' + (APPLY_STATUS == 1 ? "通过" : "作废") + '本作业票？',
        placeholderText: '请输入作废原因',
        cancelColor: "#000000",
        cancelText: '取消',
        editable: APPLY_STATUS != 1,
        confirmText: '确定',
        success: res => {
          if (res.confirm) {
            if (APPLY_STATUS != 1 && !res.content) {
              uni.showToast({
                icon: 'none',
                title: '请填写作废原因',
                duration: 1500
              });
              return;
            }
            const formData = {}
            uni.showLoading({
              title: '请稍候'
            })
            formData.HOISTING_ID = _this.pd.HOISTING_ID
            formData.SIGNTIME = signtime.join(",")
            formData.USER_ID = loginUser.USER_ID
            formData.STEP_REASON = res.content ? res.content : ''
            formData.APPLY_STATUS = APPLY_STATUS
            formData.PREPARERS = JSON.stringify(signers)
            uni.uploadFile({
              url: basePath + 'app/hoisting/nextStep',
              files: files,
              formData: formData,
              success: (res) => {
                uni.showToast({
                  icon: 'none',
                  title: '保存成功',
                  duration: 2000
                });
                _this.goback()
              },
              fail: (err) => {
                uni.showModal({
                  content: err.errMsg,
                  showCancel: false
                });
              }
            })
            uni.hideLoading();
          }
        }
      })

    },

    uploadImgFaults(files, signtime) {
      this.imgList.map((item, index) => {
        var img = {}
        img.name = 'file' + index
        img.uri = item.filePath
        files.push(img)
        signtime.push(item.SIGNER_TIME)
      })
    },

    getMeasures() {
      var _this = this;
      uni.request({
        method: 'POST',
        dataType: 'json',
        header: {
          'Content-type': 'application/x-www-form-urlencoded'
        },
        url: basePath + '/app/hoisting/listAllMeasures?tm=' + new Date().getTime(),
        data: {
          CORPINFO_ID: loginUser.CORPINFO_ID,
          USER_ID: loginUser.USER_ID,
        },
        success: function (res) {
          _this.measuresList = res.data.measuresList.map((item, index) => {
            item.userList = []
            item.userIndex = -1
            return item
          })
        }
      });
    },

    getDept() {
      var _this = this;
      uni.request({
        url: basePath + '/app/sys/listTree',//部门下拉接口
        method: 'POST',
        dataType: 'json',
        header: {
          'Content-type': 'application/x-www-form-urlencoded'
        },
        data: {
          CORPINFO_ID: loginUser.CORPINFO_ID,
          USER_ID: loginUser.USER_ID,
        },
        success: (res) => {
          if ("success" == res.data.result) {
            _this.treeNode = eval(res.data.zTreeNodes);
          } else {
            uni.showToast({
              title: res.data.message,
              duration: 2000
            });
          }
        }
      });
    },

    addMeasuresListCopy() {
      this.measuresListCopy.push({
        id: Math.random(),
        DEPARTMENT_ID: '',
        DEPARTMENT_NAME: '',
        USER_ID: '',
        USER_NAME: '',
        userList: [],
        userIndex: -1,
        selectMeasures: []
      })
    },
    removeMeasuresListCopy(index) {
      this.measuresListCopy.splice(index, 1)
    },
    fnSelectMeasures(index) {
      this.selectMeasuresShow = true
      this.selectMeasuresIndex = index
    },

    showDeptTree(index) {
      this.isUps = true
      this.$refs['tkiTree' + index][0]._show();
    },

    deptTreeConfirm(e, i) {
      this.isUps = false;
      this.measuresListCopy[i].DEPARTMENT_ID = e[0].id;
      this.measuresListCopy[i].DEPARTMENT_NAME = e[0].name;
      this.measuresListCopy[i].USER_ID = ''
      this.measuresListCopy[i].USER_NAME = ''
      this.getUserList(e[0].id, i);
    },

    deptTreeCancel(e) {
      this.isUps = false;
    },

    pickerUser(e, i) {
      for (let j = 0; j < this.measuresListCopy.length; j++) {
        if (this.measuresListCopy[j].USER_ID === this.measuresListCopy[i].userList[e.detail.value].USER_ID && i !== j) {
          uni.showToast({
            icon: 'none',
            title: '确认人不能重复',
            duration: 1500
          });
          return;
        }
      }
      this.measuresListCopy[i].userIndex = e.detail.value;
      this.measuresListCopy[i].USER_ID = this.measuresListCopy[i].userList[e.detail.value].USER_ID;
      this.measuresListCopy[i].USER_NAME = this.measuresListCopy[i].userList[e.detail.value].NAME;
      this.$forceUpdate();//强制刷新
    },

    isBlankList(i) {
      if (this.measuresListCopy[i].userList.length == 0) {
        uni.showToast({
          icon: 'none',
          title: '请先选择确认单位',
          duration: 1500
        })
      }
    },

    //获取人员列表
    getUserList(dept, i) {
      //发送 post 请求
      var _this = this
      uni.request({
        method: 'POST',
        dataType: 'json',
        header: {
          'Content-type': 'application/x-www-form-urlencoded'
        },
        url: basePath + '/app/sys/listUser',
        data: {
          DEPARTMENT_ID: dept,
          tm: new Date().getTime(),
          CORPINFO_ID: loginUser.CORPINFO_ID,
          USER_ID: loginUser.USER_ID,
        },
        success: function (res) {
          if ("success" == res.data.result) {
            _this.measuresListCopy[i].userList = res.data.userList;
          } else {
            uni.showToast({
              title: res.data.message,
              duration: 2000
            });
          }
        }
      })
    },

    /*
       *手写板
       */
    showModal(e) {
      this.modalName = e.currentTarget.dataset.target
    },
    hideModal(e) {
      this.modalName = null
    },
    DelImg(index) {
      this.imgList.splice(index, 1)
    },
    //完成
    subCanvas(e) {
      let t = {
        id: "",
        filePath: e.tempFile,
        SIGNER_TIME: formatDate(new Date(), 'yyyy-MM-dd hh:mm')
      }
      this.imgList.push(t);
      this.hideModal()
    },
    ViewImage(e) {
      let files = [];
      files.push(e.currentTarget.dataset.url)
      uni.previewImage({
        urls: files,
        current: e.currentTarget.dataset.url
      });
    },

    goback() {
      var pages = getCurrentPages();	// 获取当前页面栈
      var prePage = pages[pages.length - 2];	// 上二级页面
      prePage.$vm.initflag = true;    // A 页面 init方法 为true
      uni.navigateBack({delta: 1});
      uni.hideLoading();
    },
  }
}
</script>

<style>
.wui-sign-box1 {
  margin-top: 20upx;
  display: block;
}

.sign-img {
  position: relative;
  border-bottom: 1px dashed #eee;
  padding-top: 20upx;
}

.cu-tag {
  position: absolute;
  right: 20upx;
  top: 20upx;
}

.measures {
  padding-left: 16px;
  padding-right: 16px;

  .title {
    font-weight: bold;
    color: #000000;
    font-size: 14px;
  }

  .content {
    font-size: 14px;
    color: #000000;
    margin-top: 5px;
    margin-bottom: 5px;
  }
}
</style>
